/****************************************************************************
Module name: Dlg-Dyna.H
Programmer : Jeffrey M. Richter.
*****************************************************************************/

GLOBALHANDLE FAR PASCAL CreateDlgData(
   LONG dtStyle,
   int dtX, int dtY,       // In dialog-box units
   int dtCX, int dtCY,     // In dialog-box units
   LPSTR dtMenuName,       // "" if no menu
   LPSTR dtClassName,      // "" if standard dialog box class
   LPSTR dtCaptionText, 
   short int PointSize,    // Only used if DS_SETFONT style specified
   LPSTR szTypeFace);      // Only used if DS_SETFONT style specified



// LOWORD = Success(TRUE)/Failure(FALSE), HIWORD=New hMem
DWORD FAR PASCAL AddDlgItem (
   GLOBALHANDLE hMem,      // Handle from CreateDlgData or AddDlgItem
   int dtilX, int dtilY,   // In dialog-box units
   int dtilCX, int dtilCY, // In dialog-box units
   int dtilID,       
   long dtilStyle,         // (WS_CHILD | WS_VISIBLE) is automatically added
   LPSTR dtilClass,        // May be: "BUTTON",  "EDIT",      "STATIC",
                           //         "LISTBOX", "SCROLLBAR", "COMBOBOX"
   LPSTR dtilText,
   BYTE dtilInfo,          // Number of additional data bytes
   LPBYTE dtilData);       // Value passed through lpCreateParams field
                           // of CREATESTRUCT


void FAR PASCAL DoneAddingControls (
   GLOBALHANDLE hMem);     // Handle from CreateDlgData or AddDlgItem



#ifdef _DEMO
//****************************************************************************
// Functions for the Dynamic Dialog Box Demonstrations.

BOOL FAR PASCAL DynamicDlgProc (HWND hDlg, WORD wMsg, WORD wParam, LONG lParam);
GLOBALHANDLE FAR PASCAL BuildDynamicDlgBox (BOOL fModeless);
#endif

